Package org.eclipse.viatra.query.runtime.matchers.psystem.basicenumerables

## Class AbstractTransitiveClosure

- java.lang.Object
- - org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint
  - - org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint
    - - org.eclipse.viatra.query.runtime.matchers.psystem.KeyedEnumerablePConstraint<PQuery>
      - - org.eclipse.viatra.query.runtime.matchers.psystem.basicenumerables.AbstractTransitiveClosure

- All Implemented Interfaces:
    `IMultiQueryReference`, `IQueryReference`, `ITypeInfoProviderConstraint`, `PConstraint`, `PTraceable`
  Direct Known Subclasses:
    `BinaryReflexiveTransitiveClosure`, `BinaryTransitiveClosure`

      public abstract class AbstractTransitiveClosure
      extends KeyedEnumerablePConstraint<PQuery>
      implements IQueryReference, ITypeInfoProviderConstraint

  Since:
    2.0

- - ### Field Summary

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.KeyedEnumerablePConstraint

      `supplierKey`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint

      `variablesTuple`

    - ### Fields inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `pBody`

    - ### Fields inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.PConstraint

      `COMPARE_BY_MONOTONOUS_ID`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractTransitiveClosure​(PBody pBody, Tuple variablesTuple, PQuery supplierKey)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.Set<TypeJudgement>` | `getImpliedJudgements​(IQueryMetaContext context)` | Returns type information implied by this constraint.
    `PQuery` | `getReferredQuery()` |

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.KeyedEnumerablePConstraint

      `getSupplierKey, keyToString, toStringRestRest`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.EnumerablePConstraint

      `doReplaceVariable, getDeducedVariables, getVariableInTuple, getVariablesTuple, toStringRest`

    - ### Methods inherited from class org.eclipse.viatra.query.runtime.matchers.psystem.BasePConstraint

      `checkSanity, delete, getAffectedVariables, getBody, getFunctionalDependencies, getMonotonousID, getPSystem, replaceVariable, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.IQueryReference

      `getReferredQueries`

    - ### Methods inherited from interface org.eclipse.viatra.query.runtime.matchers.psystem.PConstraint

      `checkSanity, delete, getAffectedVariables, getBody, getDeducedVariables, getFunctionalDependencies, getMonotonousID, replaceVariable`

- - ### Constructor Detail

    - #### AbstractTransitiveClosure

          public AbstractTransitiveClosure​(PBody pBody,
                                           Tuple variablesTuple,
                                           PQuery supplierKey)

  - ### Method Detail

    - #### getReferredQuery

          public PQuery getReferredQuery()

      Specified by:
        `getReferredQuery` in interface `IQueryReference`

    - #### getImpliedJudgements

          public java.util.Set<TypeJudgement> getImpliedJudgements​(IQueryMetaContext context)

      Description copied from interface: `ITypeInfoProviderConstraint`
      Returns type information implied by this constraint.
      Specified by:
        `getImpliedJudgements` in interface `ITypeInfoProviderConstraint`
      Since:
        1.3